fieller.int <- function(x,y,y0,fixed=F,approx=F,alpha=0.05){
#   vypocet intervalu spolehlivosti pro x0,
#   ktere odpovida danemu y0
#   x,y  data, z nichz odhadnuta primka
#   fixed   zda je y0 pevna hodnota (F) i realizace nahodne veliciny
#   approx  zda se pozaduje priblizne (T) nebo Fiellerovo (F) reseni
x <- x[complete.cases(x,y)]
y <- y[complete.cases(x,y)]
b1 <- coef(a<-lm(y~x))[2]
S2 <- deviance(a)/a$df.residual
n <- length(x)
x.bar <- mean(x); y.bar <- mean(y)
Txx <- sum((x-x.bar)^2)
t2 <- qt(1-alpha/2,n-2)^2
x.Hat <- x.bar+(y0-y.bar)/b1
if (approx==F){
  A <- b1^2-S2*t2/Txx
  B <- -2*b1*(y0-y.bar)
  C <- (y0-y.bar)^2-S2*t2*((fixed==F)+1/n)
  if (A>0) {
    diskr.sqrt <- sqrt(B^2-4*A*C)
    xL <- x.bar+(-B-diskr.sqrt)/2/A
    xU <- x.bar+(-B+diskr.sqrt)/2/A
     } else {
    xL <- -Inf; xU <- Inf
    }
  } else {
  xL <- x.Hat-sqrt(S2*t2*((fixed==F)+1/n+(x.Hat-x.bar)^2/Txx))/abs(b1)
  xU <- x.Hat+sqrt(S2*t2*((fixed==F)+1/n+(x.Hat-x.bar)^2/Txx))/abs(b1)
  }
out <- c(x.Hat,xL,xU)
names(out) <- c("x.Hat","xL","xU")
return(out)
}
