#	modifikace procedury rms.curv z knihovny MASS
#	pidny mry kivosti a vychlen
#
Mrms.curv <- function(obj, 
		fit.val=obj$m$fitted(), 
		data = obj$call$data, 
		s = rep(1,p))
#   obj  vsledek nls (NUTN parametr)
#   fit.val  fce s gradientem a hessinem (NUTN)
#   data	odkaz na datov soubor
#   s		vchoz vektor pro iteran vpoet maximln kivosti
#		(dosud se mi nestalo, e by tento vchoz vektor selhal)
#   
{
       require(stats)
#
#
Mcurv.max <- function(j.min,j.max,A,s=rep(1,p),eps=1e-6,maxIter=50)
#  vpoet maximlnch kivost
#  A trojrozmrn pole rozmru p x p x n
{
p <- dim(A)[2]
s <- s/sqrt(crossprod(s,s))
i <- 0
repeat {
   i <- i + 1
   v <- rep(0,p)
   for (j in j.min:j.max) {
      As <- c(crossprod(s,A[,,j]))
      v <- v + c(crossprod(s,c(As))) * As
   }
   s <- v/sqrt(c(crossprod(v,v)))
   if (i==maxIter | crossprod(s,v)>1-eps) break
} 
v <- 0
for (j in j.min:j.max) {
   As <- crossprod(s,A[,,j])
   v <- v + c(crossprod(s,c(As)))^2
}
sqrt(v)
}
#
       v <- attr(fit.val, "gradient")
       if(is.null(v))
               stop("gradient attribute missing")
       a <- attr(fit.val, "hessian")
       if(is.null(a))
               stop("hessian attribute missing")
       p <- ncol(v)
       n <- nrow(v)
       s2 <- sum((residuals(obj))^2)/(n - p)
       sp <- sqrt(s2 * p)
       qrd <- qr(v)
       Q <- qr.Q(qrd,complete=T)
       rnk <- qrd$rank
       if(rnk <= p) warning("regression apparently linear")
       A <- array(0, c(n, p, p))
       for(j in 1:p) A[,  , j] <- crossprod(Q, a[,  , j])
       A <- aperm(A, c(2, 3, 1))
#  nyn A m rozmr p x p x n
       r11i <- solve(qr.R(qrd)[1:p, 1:p])
       ct <- 0; bias <- rep(0,p)
       for(j in 1:p) {
               A[,  , j] <- crossprod(r11i, A[,  , j]) %*% r11i
               ct <- ct + 2 * sum(A[,  , j]^2) + sum(diag(
                       as.matrix(A[,  , j])))^2
       }
       for (j in 1:p) bias <- bias+A[j,j,1:p]
       ci <- 0
       for(j in (p + 1):n) {
               A[,  , j] <- crossprod(r11i, A[,  , j]) %*% r11i
               ci <- ci + 2 * sum(A[,  , j]^2) + sum(diag(
                       as.matrix(A[,  , j])))^2
       }
#  vychlen (absolutn, pak relativn)
       bias <- -s2 * crossprod(t(r11i),bias)/2
       bias.rel <- bias/coef(obj)
#  kivosti
       Fstar <- sqrt(qf(19/20, p, n - p))
       ct.max <- Mcurv.max(1,p,A,s=s) * sp
       ci.max <- Mcurv.max(p+1,n,A,s=s) * sp
       ct <- sqrt(ct/(p * (p + 2))) * sp
       ci <- sqrt(ci/(p * (p + 2))) * sp
       ct.F <- ct * Fstar
       ci.F <- ci * Fstar
       ct.max.F <- ct.max * Fstar
       ci.max.F <- ci.max * Fstar
       val <- list(ct.F = ct.F, ci.F=ci.F, 
                   ct.max.F=ct.max.F, ci.max.F=ci.max.F,
                   ct=ct, ci=ci, 
                   ct.max=ct.max, ci.max=ci.max, 
		   thetaHat=coef(obj),
                   bias=bias,bias.rel=bias.rel, A = A)
       class(val) <- "Mrms.curv"
       val
}
#
#
print.Mrms.curv <- function(val, ...)
#	tiskov procedura pro objekt tdy "rms.curv"
{
	namTheta <- names(val$thetaHat)
       cat("Parameter effects: ", 
		format(round(val$ct, 4),width=19),
		" (max",round(val$ct.max,4),") \n",
               "       Intrinsic: ", 
		format(round(val$ci, 4),width=19),
		" (max", round(val$ci.max,4),") \n",
               ...)
       cat("Parameter effects (x sqrt(F)):", 
		format(round(val$ct.F,4),width=8),
		" (max",round(val$ct.max.F,4),") \n",
           "       Intrinsic (x sqrt(F)):", 
		format(round(val$ci.F, 4),width=8),
		" (max", round(val$ci.max.F,4),") \n",
               ...)
       cat("         Estimate",
		"     Bias",
		"  Rel. Bias","\n")
       for (j in 1:length(val$bias)) 
            cat(format(namTheta[j],width=7),
		format(round(val$thetaHat[j],3),width=10),
		format(round(val$bias[j],6),width=10),
		format(round(val$bias.rel[j]*100,3),width=10),
		" %\n",sep="")
}
