#
#	regrese, 11.kapitola Multikolinearita
#
rm(list=ls(all=TRUE))
#
A <- matrix(c(30,2,1,2,30,5,1,5,10),3,3)
B <- matrix(c(30,.02,1000,.02,.003,50,1000,50,10000000),3,3)
kappa(A,exact=TRUE)
kappa(B,exact=TRUE)/10^9
#
dA <- svd(A)$d
dA/min(dA)
dB <- svd(B)$d
dB/min(dB)
#
library(Design)
print(A0 <- matinv(A,1)[-1,-1])
print(B0 <- matinv(B,1)[-1,-1])
kappa(A0,exact=TRUE)
kappa(B0,exact=TRUE)/10^9
#
data(Iq)
attach(Iq)
cor(cbind(iq,divka,zn7,zn8))
#
summary(lm(scale(iq)~scale(divka)+scale(zn7)+scale(zn8)))
#
summary(lm(iq~divka+zn7+zn8))
#
source("VIF.R")
VIF(lm(iq~divka+zn7+zn8))
#
VIF(lm(iq~divka+zn8))
#
summary(lm(iq~divka+zn8,data=Iq))
#
ind.podm <- function(A) {e <- svd(A); e$d[1]/e$d}
ind.podm(scale(cbind(divka,zn7,zn8)))^2
ind.podm(cor(cbind(divka,zn7,zn8)))
ind.podm(cor(cbind(divka,zn7)))
#
kappa(scale(cbind(divka,zn7,zn8)),exact=TRUE)^2
kappa(cor(cbind(divka,zn7,zn8)),exact=TRUE)
#
kappa(lm(iq~scale(divka)+scale(zn7)+scale(zn8)))^2
kappa(model.matrix(~scale(divka)+scale(zn7)+scale(zn8)),exact=TRUE)^2
#
source("piMulticol.R")
piMulticol(lm(iq~divka+zn7+zn8))
piMulticol(lm(iq~divka+zn7))
#
#
#	hebenov regrese
#
data(Iq)
library(MASS)
#	podle prce 070827
#	nov hebenov diagram
#	
#	parametrizace, aby vyly korel. koef.
#	tedy model Star
iq0 <- c(scale(Iq$iq))
divka0<- c(scale(Iq$divka))
zn70 <- c(scale(Iq$zn7))
zn80 <- c(scale(Iq$zn8))
a0 <-lm(iq0~divka0+zn70+zn80)
#	potebn normalizace, aby odhady netrivilnch
#	koeficient byly sprvn i pi parametrizaci lm.ridge
#	tedy tilde
#	odhady "tilde" podle lm.ridge() z MASS
n <- length(Iq$iq)
iqTilde<-c(scale(Iq$iq,scale=FALSE))
divkaTilde<-divka0*sqrt(n)
zn8Tilde<-zn80*sqrt(n)
zn7Tilde<-zn70*sqrt(n)
aTilde <- lm(iqTilde~divkaTilde+zn7Tilde+zn8Tilde)
#
print(coef(a0))
print(coef(aTilde))
print(coef(aTilde)/coef(a0))
sigmaY2 <- crossprod(Iq$iq-mean(Iq$iq))/n
print(sqrt(sigmaY2/n))
print(sqrt(var(Iq$iq)/n))
lm.ridge(iq~divka-zn7+zn8,data=Iq)
lm(iq~divka-zn7+zn8,data=Iq)
#	vpoet odhad
delta <- seq(0,0.25,by=0.01)
aLambda<-lm.ridge(iq~divka+zn7+zn8,data=Iq,lambda=delta*n)
print(aLambda$coef[,1])
#	vykreslen kivek
matplot(delta,t(aLambda$coef),xlab=expression(delta),
	ylab=expression(b[delta]^"*"),type="l",col=1)
legend("bottomright",legend=rownames(aLambda$coef),
	lty=1:3,col=1)
#	jet bodov odhady delta
abline(v=aLambda$kLW/n,col=1)
#	ukonen zazen
#	
#	jet druh obrzek, bez zn8
#
aLambda<-lm.ridge(iq~divka+zn7,data=Iq,lambda=delta*n)
matplot(delta,t(aLambda$coef),xlab=expression(delta),
	ylab=expression(b[delta]^"*"),type="l",col=1)
legend("bottomright",legend=rownames(aLambda$coef),
	lty=1:3,col=1)
#	jet bodov odhady delta
abline(v=aLambda$kLW/n,col=1)
#	ukonen zazen
#
detach(Iq)
#
