#
#	regrese, 14. kapitola Parametrizace v NLR
#
rm(list=ls(all=TRUE))
source("obr15_2web.R")
obr15.2(NULL)	#	vyrob obr12_2N.ps
#	na pravm obrzku jsou opravdu xov souadnice bod na pmce 
#	a na kivce toton!!
#	
#
source("NLRweb.R")
NLR.priklad(x2=6,delka=.45)	#	vyrob obr15_4.ps
#
#	simulace jako Donaldsonov, Schnabel
data(celek)
#	parametrick kivost
plot(1-celek[,"Wald"]~log(celek[,"par."]),pch=16,ylim=0:1,
	xlab=expression(log(K^{T} *sqrt(F[k,n-k](alpha)))),
	ylab="spolehlivost")
abline(h=c(1,0.95,0.90),v=0,lty=c(1,2,3,3))
#
#	vnitn kivost
plot(1-celek[,"LR"]~log(celek[,"int."]),pch=16,ylim=0:1,
	xlab=expression(log(K^{N} *sqrt(F[k,n-k](alpha)))),
	ylab="spolehlivost")
abline(h=c(1,0.95,0.90),v=0,lty=c(1,2,3,3))
#
#	vpoet pkladu Puromycin
source("MODIFrms.R")
data(Puromycin)
fceMM <- deriv3(~Vm*x/(K+x), namevec=c("Vm","K"), 
		function.arg=function(x,Vm,K){})
purTrtHess <- nls(rate~fceMM(conc,Vm,K),data=Puromycin,
		subset=state=="treated",start=c(Vm=300,K=1))
Mrms.curv(purTrtHess)
purUntrtHess <- nls(rate~fceMM(conc,Vm,K),data=Puromycin,
		subset=state!="treatment",start=c(Vm=300,K=1))
Mrms.curv(purUntrtHess)
#
#	vpoet kivost lohy farmakolog
#
data(Kan)
fce_bc <- deriv3(~(x+(625-x)*(1-exp(-b*x/(625-x))))/c,
	namevec=c("b","c"),function.arg=function(x,b,c){})
f.Kan <- nls(y~fce_bc(x,b,c),start=list(b=2.5,c=4),data=Kan)
fce_bd <- deriv3(~(x+(625-x)*(1-exp(-b*x/(625-x))))*d,
	namevec=c("b","d"),function.arg=function(x,b,d){})
ff.Kan <- nls(y~fce_bd(x,b,d),start=list(b=5,d=.1),data=Kan)
Mrms.curv(f.Kan)
Mrms.curv(ff.Kan)
#

