VIF <- function(lmobj)
#  lmobj	objekt tdy "lm"
#  pot diagnostick statistiky souvisejc s multikolinearitou
#  zaloen na korelan matici
#  pedpokld absolutn len
{
if (!is.null(weights(lmobj)))
	stop("requires unweighted model")
if (!(any(names(coefficients(lmobj))=="(Intercept)")))
	stop("requires model with intercept")
X0 <- scale(model.matrix(lmobj))[,-1]	# standardizace regresor
if (is.null(dim(X0))) stop("requires at least two regressors")
nam <- labels(terms(lmobj))[-1]
y0 <- scale(lmobj$model[,1])		# standardizace regresandu
lmobj0 <- lm(y0~X0)			# standardizovan regrese
VIF <- diag(solve(cor(X0)))
tol <- 1/VIF; R2 <- 1-tol
b.star <- coef(lmobj0)[-1]		# vynech identickou nulu
out <- cbind(b.star,VIF,R2,tol)
rownames(out) <- labels(coef(lmobj))[-1]#doporuil L. Kotk
return(out)
}
