#	modifikace 071027
#
metodyOdhadu <- function(t01=2,t02=2,#
	tt1=c(0.5,2.5),tt2=c(0.5,2.25),xVec=c(-1,0,1),yVec=c(0,1,2),nn=21){
#
fce <- deriv3(~t1*exp(t2*x),namevec=c("t1","t2"),function.arg=function(x,t1,t2){})
#	fce <- function(x,t1,t2){
#	regresn funkce
#	t1*exp(t2*x)
# }
dev <- function(t_1,t_2){
#	deviance
sum((yVec-fce(xVec,t_1,t_2))^2)
}
#
fce1 <- function(x){
#	pro optimalizaci rho
dev(t1+x*d[1],t2+x*d[2])	
}
#
#
xx <- seq(tt1[1],tt1[2],length=nn)
yy <- seq(tt2[1],tt2[2],length=nn)
zz <- matrix(NA,nn,nn)
for (i in 1:nn) for (j in 1:nn) zz[i,j] <- dev(xx[i],yy[j])
contour(xx,yy,log(zz),levels=-1:5, asp=1,lty=3)
text(t01,t02,expression(bolditalic(t)^{(0)}),pos=4)
#
a.nls <- nls(yVec~t1*exp(t2*xVec),start=c(t1=t01,t2=t02),trace=TRUE)
summary(a.nls)
points(coef(a.nls)[1],coef(a.nls)[2],pch=17)
text(coef(a.nls)[1],coef(a.nls)[2],expression(bolditalic(t)),pos=2)
#	jednotlive iterace
#
#	Gaussova metoda
#
rho <- 1
t1 <- t01; t2 <- t02
Gauss <- c(t1,t2)
for (krok in 1:8){
	points(t1,t2,pch=1)
	rez <- yVec-fce(xVec,t1,t2)
	F <- attr(fce(xVec,t1,t2),"gradient")
	d <- qr.coef(qr(F),rez)
	t1Old <- t1; t2Old <- t2
	t1 <- t1 + rho*d[1]
	t2 <- t2 + rho*d[2]
	Gauss <- rbind(Gauss,c(t1,t2))
	lines(c(t1,t1Old),c(t2,t2Old),lty=1)
#	elipsa lin. aproximace reg. fce
#if (krok==3) {
#	a <- seq(0,2*pi,length=101)
#	FtF <- solve(crossprod(F,F))
#	scale <- sqrt(diag(FtF))
#	C <- rho*sqrt(crossprod(d,crossprod(FtF,d)))*9
#	r <- FtF[1,2]/scale[1]/scale[2]
#	acr <- acos(r)/2
#	lines(C*scale[1]*cos(a+acr)+t1,C*scale[2]*cos(a-acr)+t2,col=1,lty=1)
#	}
}
#
#	gradientn metoda
#
rho <- 1
t1 <- t01; t2 <- t02
Gradient <- c(t1,t2)
for (krok in 1:8){
	points(t1,t2,pch=2)
	rez <- yVec-fce(xVec,t1,t2)
	F <- attr(fce(xVec,t1,t2),"gradient")
	d <- 2*crossprod(F,rez)
	t1Old <- t1; t2Old <- t2
	rho <- optimize(fce1,c(0,1/sqrt(crossprod(d))))$minimum
	t1 <- t1Old + rho*d[1]
	t2 <- t2Old + rho*d[2]
	Gradient <- rbind(Gradient,c(t1,t2))
	lines(c(t1,t1Old),c(t2,t2Old),lty=2)
}
#
#	Newtonova metoda
rho <- 1
t1 <- t01; t2 <- t02
Newton <- c(t1,t2)
for (krok in 1:6){
	points(t1,t2,pch=3)
	fceVal <- fce(xVec,t1,t2)
	rez <- yVec-fceVal
	F <- attr(fceVal,"gradient")
	d <- 2*crossprod(F,rez)
	D <- 2*crossprod(F,F)
	for (i in 1:length(xVec)) D <- D - rez[i]*attr(fceVal,"hessian")[i,,]
	d <- solve(D,d)
print(krok)
print(d)
print(c(prod(eigen(D)$values),log(dev(t1,t2))))
	t1Old <- t1; t2Old <- t2
	rho <- optimize(fce1,c(0,1))$minimum
print(rho)
	t1 <- t1Old + rho*d[1]
	t2 <- t2Old + rho*d[2]
	Newton <- rbind(Newton,c(t1,t2))
	lines(c(t1,t1Old),c(t2,t2Old),lty=4)
}
legend("topright",legend=c("Gauss","gradient","Newton"),
	lty=c(1,2,4),pch=1:3)
#	 
return(list(Gauss=Gauss,Gradient=Gradient,Newton=Newton))
}


